10 REM *** Serial Project Test Program 1 Version 1.2
20 REM *** Copyright (C) Paul Stenning, 1992-1994.
30 REM
35 REM *** Source Code for QuickBASIC, QBASIC, BASIC-A and GW-BASIC
36 REM
37 REM
40 SCREEN 0: CLS
50 PRINT "Serial Test Program 1  -  (C) Paul Stenning, 1994"
60 PRINT
61 INPUT ; "Which Serial Port (1 or 2) "; p$
62 IF LEN(p$) <> 1 THEN BEEP: PRINT "    INVALID INPUT": GOTO 61
63 IF VAL(p$) < 1 OR VAL(p$) > 2 THEN BEEP: PRINT "    INVALID INPUT": GOTO 61
64 ON ERROR GOTO 500
70 OPEN "COM" + p$ + ":9600,N,8,1,CS0,CD0,DS0" FOR RANDOM AS #1 LEN = 1
72 PRINT "    ok": PRINT : PRINT
74 ON ERROR GOTO 600
80 INPUT ; a$
90 IF a$ = "" THEN PRINT "QUIT": CLOSE #1: END
100 IF LEN(a$) <> 2 THEN PRINT TAB(10); "INPUT ERROR": GOTO 80
101 a1% = ASC(UCASE$(LEFT$(a$, 1))): a2% = ASC(UCASE$(RIGHT$(a$, 1)))
102 IF (a1% > 47 AND a1% < 58) OR (a1% > 64 AND a1% < 71) THEN GOTO 105
103 PRINT TAB(10); "INPUT ERROR": GOTO 80
105 IF (a2% > 47 AND a2% < 58) OR (a2% > 64 AND a2% < 71) THEN GOTO 110
106 PRINT TAB(10); "INPUT ERROR": GOTO 80
110 PRINT #1, CHR$(VAL("&h" + a$));
120 TIMEOUT = TIMER + .1
130 IF EOF(1) AND TIMER < TIMEOUT THEN GOTO 130
140 IF TIMER >= TIMEOUT THEN PRINT TAB(10); "**": GOTO 80
150 a$ = HEX$(ASC(INPUT$(1, #1)))
160 IF LEN(a$) < 2 THEN a$ = "0" + a$
170 PRINT TAB(10); a$
180 GOTO 80

500 CLOSE
510 PRINT : PRINT : PRINT
520 PRINT "ERROR OPENING COM"; p$; "  -  PROGRAM TERMINATED!"
530 PRINT : END

600 CLOSE
610 PRINT : PRINT
620 PRINT "ERROR COMMUNICATING THROUGH COM"; p$; "  -  PROGRAM TERMINATED!"
630 PRINT : END

